<template>
    <!-- 导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="open" :width="upload.width" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <div class="el-upload__tip" slot="tip">
            <el-checkbox v-model="upload.updateSupport" /> 是否更新已经存在的用户数据
          </div>
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link type="primary" :underline="false" style="font-size:12px;vertical-align: baseline;" @click="importTemplate">下载模板</el-link>
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
</template>
<script>
import { getToken } from "@/utils/auth";
export default {
    name: 'UploadBox',
    data() {
        return {
            // 是否显示弹出层（用户导入）
            open: false,
            // 用户导入参数
            upload: {
                width: '400px',
                // 弹出层标题（用户导入）
                title: "导入",
                // 是否禁用上传
                isUploading: false,
                // 是否更新已经存在的用户数据
                updateSupport: 0,
                // 设置上传的请求头部
                headers: { Authorization: "Bearer " + getToken() },
                // 下载模板地址
                importTemplate: '',
                // 上传的地址
                url:  ""
            },
        }
    },
    methods: {
        initData(data) {
            this.upload = Object.assign(this.upload,{},data)
            this.upload.importTemplate = data.importTemplate ? (process.env.VUE_APP_BASE_API + data.importTemplate) :  ''
            this.upload.url = data.url ? (process.env.VUE_APP_BASE_API + data.url) :  ''
            this.upload.headers = { Authorization: "Bearer " + getToken() }
            this.open = true
        },
        /** 下载模板操作 */
        importTemplate() {
            this.download(this.upload.importTemplate, {
            }, `导入模板_${new Date().getTime()}.xlsx`)
        },
        // 文件上传中处理
        handleFileUploadProgress(event, file, fileList) {
            this.upload.isUploading = true;
        },
        // 文件上传成功处理
        handleFileSuccess(response, file, fileList) {
            this.upload.open = false;
            this.upload.isUploading = false;
            this.$refs.upload.clearFiles();
            this.$alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + "</div>", "导入结果", { dangerouslyUseHTMLString: true });
            this.$emit('refresh')
        },
         // 提交上传文件
        submitFileForm() {
            this.$refs.upload.submit();
        }
    },
}
</script>
